extends Area2D

onready var global_v=get_tree().get_root().get_node("scene")

var shoot_mov=170.0

var del_it=false
var is_hit=false
var cfree=false
var start_time=0.0
var start_pos=0.0
var del_timer=0.0
var once=true

var angle=0

var vel=Vector2()

func _ready():
	get_node("../").position=start_pos
	connect("body_entered",self,"_on_b1_body_entered")
	
	var md = Transform2D()
	md = md.translated(Vector2(shoot_mov,0))
	md = md.rotated(angle)
	vel = md.get_origin()

func _on_b1_body_entered(body):
	if(del_it):
		return
	if(body.is_a_parent_of(self)):
		return
	get_node("../../paint_FBO/Sprite").update_expl(get_node("../").position,global_v.iTime)
	del_it=true
	is_hit=true
	return

func Spherex(p):
	var s=500
	return p.length()-s

func free_shoot():
	cfree=true
	get_node("../").visible=false
	get_node("../").queue_free()
	self.transform


func _process(delta):
	if(cfree):
		return
	if(del_it):
		if(once):
			disconnect("body_entered",self,"_on_b1_body_entered")
			if(is_hit):
				get_node("../on_hit").emitting=true
			get_node("../f").emitting=false
			once=false
		del_timer+=delta
		if(del_timer>3+3):
			free_shoot()
	else:

		get_node("../").translate(vel* delta)
		if(Spherex(start_pos-get_node("../").position)>=1):
			del_it=true
	start_time+=delta
